'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPrimitives = require('react-primitives');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinearGradient = function (_PureComponent) {
  _inherits(LinearGradient, _PureComponent);

  function LinearGradient(props) {
    _classCallCheck(this, LinearGradient);

    var _this = _possibleConstructorReturn(this, (LinearGradient.__proto__ || Object.getPrototypeOf(LinearGradient)).call(this, props));

    _this.measure = function (_ref) {
      var nativeEvent = _ref.nativeEvent;
      return _this.setState({
        width: nativeEvent.layout.width,
        height: nativeEvent.layout.height
      });
    };

    _this.getAngle = function () {
      // Math.atan2 handles Infinity
      var angle = Math.atan2(_this.state.width * (_this.props.end.y - _this.props.start.y), _this.state.height * (_this.props.end.x - _this.props.start.x)) + Math.PI / 2;
      return angle + 'rad';
    };

    _this.getColors = function () {
      return _this.props.colors.map(function (color, index) {
        var location = _this.props.locations[index];
        var locationStyle = '';
        if (location) {
          locationStyle = ' ' + location * 100 + '%';
        }
        return color + locationStyle;
      }).join(',');
    };

    _this.state = {
      width: 1,
      height: 1
    };
    return _this;
  }

  _createClass(LinearGradient, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactPrimitives.View,
        {
          style: [this.props.style, { backgroundImage: 'linear-gradient(' + this.getAngle() + ',' + this.getColors() + ')' }],
          onLayout: this.measure
        },
        this.props.children
      );
    }
  }]);

  return LinearGradient;
}(_react.PureComponent);

LinearGradient.defaultProps = {
  start: {
    x: 0.5,
    y: 0
  },
  end: {
    x: 0.5,
    y: 1
  },
  locations: [],
  colors: []
};
LinearGradient.propTypes = {
  start: _propTypes2.default.object,
  end: _propTypes2.default.object,
  locations: _propTypes2.default.array,
  colors: _propTypes2.default.array
};

exports.default = LinearGradient;